add copyright, fix arch
[automated-distro-installer] / faiserver-setup
index 54b69f617edcf6ba3966e8ede477c06e56a3b398..617a3dc04d80c50fbd5168aa2b72c2da18012cc5 100755 (executable)
@@ -1,9 +1,27 @@
 #!/bin/bash
+# Copyright (C) 2016 Ian Kelling
 
-# initial setup of a fai server on debian
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+# Initial setup of a fai server on debian. works on localhost.
+# Set's the current ip as the tftp server. I vaguely remember
+# that using a hostname does not work
+# Requires changing dns to point faiserver and running fai-redep
 
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 [[ $EUID == 0 ]] || exec sudo "${BASH_SOURCE}" "$@"
 
@@ -25,18 +43,19 @@ to_install=()
 for pkg in $deps; do
     dpkg -s $pkg &>/dev/null && continue ||:
     to_install+=($pkg)
-    echo $pkg >> /etc/fai/fai-manually-installed-packages
+    echo $pkg >>/etc/fai/fai-manually-installed-packages
 done
 if [[ $to_install ]]; then
     apt-get -y install ${to_install[@]}
 fi
 
-sed -i 's/^#deb/deb/' /etc/fai/apt/sources.list
-sed -i 's/#LOGUSER/LOGUSER/' /etc/fai/fai.conf
+sed="sed -ri --follow-symlinks"
+$sed 's/^#deb/deb/' /etc/fai/apt/sources.list
+$sed 's/#LOGUSER/LOGUSER/' /etc/fai/fai.conf
 # from man fai-make-nfsroot,
 # figured out after partitioning ignored my crypt partition
 if ! grep cryptsetup /etc/fai/NFSROOT &>/dev/null; then
-    sed -ri '/^PACKAGES install$/a cryptsetup' /etc/fai/NFSROOT
+    $sed '/^PACKAGES install$/a cryptsetup' /etc/fai/NFSROOT
 fi
 fai-setup -vf
 { head -n 1 /srv/fai/nfsroot/root/.ssh/known_hosts | awk '{print $1}' \
@@ -44,7 +63,7 @@ fai-setup -vf
     } >>/srv/fai/nfsroot/root/.ssh/known_hosts
 
 # this does not alter the config on a new install
-sed -ri 's#^([[:space:]]*TFTP_DIRECTORY[[:space:]]*=).*#\1"/srv/tftp"#' \
+$sed 's#^([[:space:]]*TFTP_DIRECTORY[[:space:]]*=).*#\1"/srv/tftp"#' \
     /etc/default/tftpd-hpa
 
 service tftpd-hpa restart
@@ -60,9 +79,10 @@ service tftpd-hpa restart
 # Add debug to -f flag for more verbose output.
 
 std_arg="-u nfs://faiserver/srv/fai/config"
-fai-chboot -Iv $std_arg default # reset so we are idempotent
+fai-chboot -Iv $std_arg default # reset so we are idempotent
 kernel=$(fai-chboot -L '^default$' | awk '{print $3}')
 type -t host &>/dev/null || apt-get -y install dnsutils
+# resolve host using gateway address
 my_ip=$(host faiserver $(route -n | sed -rn 's/^(0\.){3}0\s+(\S+).*/\2/p') | \
                sed -rn 's/^\S+ has address //p')
 k_args=$(fai-chboot -L '^default$' | \
@@ -89,6 +109,6 @@ apt-get -y install apt-cacher-ng
 # the logsave prompted because the hostname faiserver was uknown.
 # Here it was faiserver.lan when running from a faiserver vm.
 # When running from a normal host with faiserver alias, it was the normal hosts name.
-sed -ri 's/(^[^,]+,)\S+/\1faiserver/' /srv/fai/nfsroot/root/.ssh/known_hosts
+$sed 's/(^[^,]+,)\S+/\1faiserver/' /srv/fai/nfsroot/root/.ssh/known_hosts
 # ditch the logo banner up top which screws with less.
 touch /srv/fai/nfsroot/.nocolorlogo